//    case 117:

void ProcessDistillFractional()
{
  if (flAlarmUroven && StateMachine<4) 
  { // Если сработал датчик уровня, то переходим на следующую фракцию.
    TekFraction++; SecTempPrev=Seconds; 
    flAlarmUroven=0;
    CountAlarmUroven=0;
    if (TekFraction<CountFractionDist) SetAngle(AngleFractionDist[TekFraction]);
    if (BeepStateProcess) my_beep(BEEP_LONG);
  }

  // Проверяем температуру в ТСА
  if (temps[TEMP_TSA]>=MAX_TEMP_TSA) 
  {
    StateMachine=101; // Переводим автомат в состояние аварии по ТСА.
    UstPower=0;
  }

  if (flAlarmMPX5010) StateMachine=100; // Переводим в режим тревоги по датчику давления
  
  switch  (StateMachine)
  {
  case 0: // Процесс не запущен
    break;
  case 1: // Начало процесса
    PrepareProcess();
    //          if (FlToGSM && lastSMSState!=StateMachine) StateToSMS();
    lastSMSState=0;

    KlOpen[KLP_VODA]=PER_KLP_OPEN;
    KlClose[KLP_VODA]=PER_KLP_CLOSE;
    StateMachine=2;
    if (BeepStateProcess) my_beep(BEEP_LONG);
//    digitalWrite(PIN_REG_ON,HIGH);
    digitalWrite(PIN_RZG_ON,RELAY_HIGH);
    digitalWrite(PIN_ALL_OFF,!ALL_OFF_HIGH);
    digitalWrite(PIN_START_1,RELAY_HIGH);
    digitalWrite(PIN_START_2,RELAY_HIGH);
    flAllOff=0;

  case 2: // Ожидание, пока прогреется термометр в дефлегматоре

    UstPower=Power; // Устанавливаем максимальную мощность для разгона
    // Подчиненные переводим в разгон
    digitalWrite(PIN_SLAVE_0, 1);
    digitalWrite(PIN_SLAVE_1, 0);
    digitalWrite(PIN_SLAVE_2, 0);
    digitalWrite(PIN_SLAVE_3, 0);

    // Если температура в дефлегматоре меньше 70 градусов и датчик дефлегматора в принципе подключен, тогда ждем, пока
    // дефлегматор прогреется, чтобы запустить воду в холодильник (это для некоторой экономии воды)
    if (temps[TEMP_DEFL]<TempDeflBegDistil && ds1820_devices>1 || (TempDeflBegDistil<0 &&  temps[TEMP_KUB]<-TempDeflBegDistil) ) break;

    // Подаем питание на клапан подачи воды холодильника
    // для этого синхронизируем его с клапаном общей подачи воды (возможно, при этом будет меньше гидроударов, хотя я их и так не наблюдаю)
    KlOpen[KLP_HLD]=KlOpen[KLP_VODA];
    KlClose[KLP_HLD]=KlClose[KLP_VODA];
    KlState[KLP_HLD]=KlState[KLP_VODA];
    KlCount[KLP_HLD]=KlCount[KLP_VODA];
    StateMachine=3;        
    if (BeepStateProcess) my_beep(BEEP_LONG);
    digitalWrite(PIN_RZG_ON,!RELAY_HIGH);
    TekFraction=0;
    SetAngle(AngleFractionDist[TekFraction]);
    SecTempPrev=Seconds;

  case 3:// Ждем, пока температура в кубе не превысит установленную
    digitalWrite(PIN_SLAVE_0, 0);
    digitalWrite(PIN_SLAVE_1, 0);
    digitalWrite(PIN_SLAVE_2, 1); // Переводим подчиненный в режим дистилляции
    digitalWrite(PIN_SLAVE_3, 0);

    if (TekFraction<CountFractionDist)
    {    
      if (TekFraction==0 && CountFractionDist==2) // Если число фракций равно ровно две, тогда отбираем первую фракцию через клапан голов, остальные через клапан тела
      {
          // Для первой фракции (считаем ее головами) открываем клапан отбора голов, клапан тела закрываем.
          KlOpen[KLP_SR]=0;
          KlClose[KLP_SR]=10;
          KlOpen[KLP_GLV_HVS]=200;
          KlClose[KLP_GLV_HVS]=0;  
      }
      else
      {   // Для последующих фракций (считаем их телом) клапан тела открываем, клапан голов закрываем.
          KlOpen[KLP_SR]=200;
          KlClose[KLP_SR]=0;
          KlOpen[KLP_GLV_HVS]=0;
          KlClose[KLP_GLV_HVS]=10;          
      }
      UstPower=PowerFractionDist[TekFraction]; // Устанавливаем максимальную мощность для разгона
      TekTemp=TempFractionDist[TekFraction]; //Текущее состояние - первый недробный перегон
      if (TekTemp>=0) // Значение больше нуля, значит это температура
      {
        if (temps[TEMP_KUB]>=TekTemp)
        {  
           TekFraction++; SecTempPrev=Seconds; 
           if (TekFraction<CountFractionDist) SetAngle(AngleFractionDist[TekFraction]);
        }
      }
      else
      {
        // Значение меньше нуля, значит это время в минутах
          SecOstatok=-((Seconds-SecTempPrev) / 60 + TekTemp);
        // Если времени не осталось, переходим на следующую фракцию  
        if (SecOstatok<=0) 
         { 
           TekFraction++; SecTempPrev=Seconds; 
           if (TekFraction<CountFractionDist) SetAngle(AngleFractionDist[TekFraction]);
         }
        
      }    
     break; 
    }
    else
    {
      StateMachine=4;        
      time3=2*60+((int)(FlAvtonom>>1))*60;// Через две минуты отключим воду
      if (BeepStateProcess) my_beep(BEEP_LONG);
    }
    
  case 4:// Ждем минуту для окончания подачи воды
    UstPower=0;
    // Закрываем клапана на отбор.
    KlOpen[KLP_SR]=0;
    KlClose[KLP_SR]=10;
    KlOpen[KLP_GLV_HVS]=0;
    KlClose[KLP_GLV_HVS]=10;      
    digitalWrite(PIN_START_1,!RELAY_HIGH);
    digitalWrite(PIN_START_2,!RELAY_HIGH);
    
    // Отключаем подчиненные
    digitalWrite(PIN_SLAVE_0, 0);
    digitalWrite(PIN_SLAVE_1, 0);
    digitalWrite(PIN_SLAVE_2, 0); 
    digitalWrite(PIN_SLAVE_3, 0);
//    SecondsEnd=SecondsEnd-(Seconds-SecTempPrev);
//    SecTempPrev=Seconds;
//
//    if (SecondsEnd<=0)
    if (time3==0)
    {
      // Переводим автомат в конечное состояние
      StateMachine=100;        
      SecondsEnd=Seconds;
      if (BeepStateProcess) my_beep(BEEP_LONG);
    }
    break;
  case 101: // Превышение температуры в ТСА!!!
    my_beep(3*BEEP_LONG);
  case 100:// Конечное состояние автомата
    // Отключаем на всякий случай все!
    if (FlToGSM && lastSMSState!=StateMachine) StateToSMS();
    if (BeepEndProcess) my_beep(BEEP_LONG);
    UstPower=0;
    // Отключаем подчиненные
    digitalWrite(PIN_SLAVE_0, 0);
    digitalWrite(PIN_SLAVE_1, 0);
    digitalWrite(PIN_SLAVE_2, 0); 
    digitalWrite(PIN_SLAVE_3, 0);
    CloseAllKLP();
//    digitalWrite(PIN_REG_ON,LOW);
    digitalWrite(PIN_RZG_ON,!RELAY_HIGH);
    digitalWrite(PIN_ALL_OFF,ALL_OFF_HIGH);
    digitalWrite(PIN_START_1,!RELAY_HIGH);
    digitalWrite(PIN_START_2,!RELAY_HIGH);
    flAllOff=1;

    break;
  }

}
