//    case 111:

void ProcessNDRF()
{

  //#define KLP_NPG  0      // Номер клапана для управления НПГ (при дистилляции) 
  //#define KLP_VODA 1      // Номер клапана для управления общей подачей воды в систему
  //#define KLP_DEFL 2      // Номер клапана для подачи воды в дейфлегматор
  //#define KLP_GLV_HVS  3       // Номер клапана отбора головных и хвостовых фракций
  //#define KLP_SR   4      // Номер клапана отбора ректификата
  //#define TEMP_KUB  0      // Номер датчика  термометра в кубе
  //#define TEMP_RK20 1      // Номер датчика термометра в РК 20 см от насадки
  //#define TEMP_TSA  2      // Номер термометра в трубке связи с атмосферой
  static char Count_Provodimost=0; // Количество срабатываний датчика проводимости для окончания отбора голов.
  static char OldStateMachine=0; // Количество срабатываний датчика проводимости для окончания отбора голов.
  int V3; // Текущий уровень проводимости;

  if (flAlarmUroven && StateMachine<8 ) 
  { // Переводим автомат в стадию завершения 
    if (USE_ALARM_UROVEN==1)
    {
      StateMachine=8; // Переводим в режим окончания
      SecTempPrev=Seconds;// Запомним время, когда закончилась ректификация
      if (BeepStateProcess) my_beep(BEEP_LONG);
    }
    else
    {
      OldStateMachine=StateMachine;
      StateMachine=9;  // Переводим в режим ожидания
      if (BeepStateProcess) my_beep(BEEP_LONG);
      Count_Provodimost=0;
      KlOpen[KLP_GLV_HVS]=0;
      KlClose[KLP_GLV_HVS]=100;
      KlOpen[KLP_SR]=0;
      KlClose[KLP_SR]=100;
    }
  }

  // Проверяем температуру в ТСА
  if (temps[TEMP_TSA]>=MAX_TEMP_TSA) 
  {
    StateMachine=101; // Переводим автомат в состояние аварии по ТСА.
  }

  if (flAlarmMPX5010) StateMachine=102; // Переводим в режим тревоги по датчику давления
  
 // Проверяем окончание температуры окончания ректификации
  if (temps[TEMP_KUB]>=tEndRect  && StateMachine<8 && IspReg!=118 )
  {  
    StateMachine=8;        
    SecTempPrev=Seconds;// Запомним время, когда закончилась ректификация
    if (BeepStateProcess) my_beep(BEEP_LONG);
  }
  
  switch  (StateMachine)
  {
  case 0: // Процесс не запущен
    break;
  case 1: // Начало процесса
    PrepareProcess();
    KlReg[KLP_GLV_HVS]=PEREGREV_ON;
    KlReg[KLP_SR]=PEREGREV_ON;

    //          if (FlToGSM && lastSMSState!=StateMachine) StateToSMS();
    lastSMSState=0;

    KlOpen[KLP_VODA]=PER_KLP_OPEN;
    KlClose[KLP_VODA]=PER_KLP_CLOSE;
//    digitalWrite(PIN_REG_ON,HIGH);
    digitalWrite(PIN_RZG_ON,RELAY_HIGH);
    digitalWrite(PIN_ALL_OFF,!ALL_OFF_HIGH);
    digitalWrite(PIN_START_1,RELAY_HIGH);
    digitalWrite(PIN_START_2,RELAY_HIGH);
    flAllOff=0;
    StateMachine=2;
    if (BeepStateProcess) my_beep(BEEP_LONG);
    Count_Provodimost=0;
  case 2: // Разгон
    UstPower=Power; // Устанавливаем максимальную мощность для разгона

    // Учитываем как температуру в кубе, так и температуру в колонне, в зависимости от того, положительные или отрицательные значения температур.
    if (temps[TEMP_KUB]<tEndRectRazgon  && tEndRectRazgon>0) break;
    if (temps[TEMP_RK20]<-tEndRectRazgon && tEndRectRazgon<=0) break;

    // Подаем питание на клапан дефлегматора
    KlOpen[KLP_DEFL]=PER_KLP_OPEN;
    KlClose[KLP_DEFL]=PER_KLP_CLOSE;
    TempPrev=temps[TEMP_RK20];
    SecTempPrev=Seconds; // Запоминаем дату последнего изменения температуры
    SecOstatok=1800; // Стаблилизация колонный по-умолчанию полчаса
    StateMachine=3;        
    digitalWrite(PIN_RZG_ON,!RELAY_HIGH);
    if (BeepStateProcess) my_beep(BEEP_LONG);

  case 3:// Стабилизация температуры (строго по времени)
    UstPower=PowerRect;
    // Польский буфер откроем.
    KlOpen[KLP_PB]=200;
    KlClose[KLP_PB]=0;
    
    if (temps[TEMP_RK20]>0) // Если температура больше 70 градусов (вдруг куб прогрелся, а колонна еще нет, нелогично, конечно, но на всякий случай учтем)
    {
      // Стабилизация строго по температуре 
      SecOstatok=SecOstatok-(Seconds-SecTempPrev);
      SecTempPrev=Seconds;
      if (SecOstatok<=0) 
      {
        StateMachine=4;
        SecTempPrev=Seconds;
      }
      else
        break;
    }
    else
    { 
      SecTempPrev=Seconds; // Запоминаем дату последнего изменения температуры
      break;
    }  

  case 4: // Отбор голов
    UstPower=PowerRect;
    //unsigned int timeChimRectOtbGlv=2000;  // Шим отбора голов (в полупериодах сетевого напряжения в данном случае это около 20 секунд)
    //unsigned char ProcChimOtbGlv=5;  // Процент ШИМ отбора голов (в данном случае это 5 процентов)
    // Устанавливаем клапан отбора хвостов и голов в соответвии с установленнным ШИМ
    //int tEndRectOtbGlv=854;     // Температура окончания отбора голов 85.4 С
    KlOpen[KLP_SR]=0;
    KlClose[KLP_SR]=10;
    // Польский буфер закроем.
    KlOpen[KLP_PB]=0;
    KlClose[KLP_PB]=10;
    
    if (ProcChimOtbGlv>0)
        KlOpen[KLP_GLV_HVS]=(timeChimRectOtbGlv/100)*ProcChimOtbGlv;
    else
        KlOpen[KLP_GLV_HVS]=-ProcChimOtbGlv;
         
    KlClose[KLP_GLV_HVS]=timeChimRectOtbGlv-KlOpen[KLP_GLV_HVS];
    tStabSR=temps[TEMP_RK20];// Это температура, относительно которой будем стабилизировать отбор


    if (UrovenProvodimostSR==0) // Если проводимость спирта не используется, головы отбираем по температуре
    {
      if (temps[TEMP_KUB]<tEndRectOtbGlv)
      {  // Пока температура в кубе не выросла выше окончания отбора голов, продолжаем это состояни
        break;       
      }
    }
    else
    {

      if (UrovenProvodimostSR>0) // Если проводимость больше нуля, используем проводимость в том или ином виде
      {
        V3=U_GLV; 
        // Если проводимость менее заданного уровня, и проводимость вообще сущетвует, то увеличиваем счетчик срабатываний
        // или ести проводимость больше уровня тревоги и установлен признак отбирать головы по уровню в приемной емкости.
  
        if ((V3<UrovenProvodimostSR && V3>=2 && UrovenProvodimostSR>=5) || (V3>=UROVEN_ALARM && UrovenProvodimostSR<=2 )) 
        {
          my_beep(BEEP_LONG); // Сначала пищим, предупреждая.
          Count_Provodimost++;
        }
        else 
          Count_Provodimost=0;
  
        // Если счетчик срабатываний не превысил максимальное число раз, тогда продолжаем процесс отбора голов.
        if (Count_Provodimost<MAX_COUNT_PROVODIMOST_SR) break;
      } 
      else // Если уровень проводимости SR меньше нуля, тогда это означает, что отбор голов производится по времени (в десятках минут).
      {
        // Анализируем, сколько минут прошло с начала отбора голов.
        SecOstatok=-((Seconds-SecTempPrev) / 600 + UrovenProvodimostSR);
        if (SecOstatok>0) break;
      }
    }

    // Если температура превысила указанный рубеж, то переходим в состояние отбора спирта-ректификата.
    // Клапан отбора голов и хвостов отключаем
    tStabSR=temps[TEMP_RK20];// Это температура, относительно которой будем стабилизировать отбор
    KlOpen[KLP_GLV_HVS]=0;
    KlClose[KLP_GLV_HVS]=10;
    ProcChimSR=begProcChimOtbSR;
    StateMachine=5;        
    if (BeepStateProcess) my_beep(BEEP_LONG);

  case 5: // Ожидание, пока температура не вернется к состоянию стабилизации
    // Это для отладки страт-стопа, на самом деле температура 28,5 градуса в этом режиме в колонне быть не может
    if (tStabSR==0) tStabSR=285;

    KlOpen[KLP_GLV_HVS]=0;
    KlClose[KLP_GLV_HVS]=10;
    KlOpen[KLP_SR]=0;
    KlClose[KLP_SR]=10;
    if (temps[TEMP_KUB]>=tEndRectOtbSR)
    {  
      StateMachine=7;        
      if (BeepStateProcess) my_beep(BEEP_LONG);
      break;
    }

    if (temps[TEMP_RK20]>tStabSR)
    {
      break;
    }
    SecTempPrev=Seconds;// Запомним время, когда стабилизировалась температура
    StateMachine=6;        
    if (BeepStateProcess) my_beep(BEEP_LONG);
  case 6: // Отбор СР
    //unsigned int timeChimRectOtbSR=1000;  // Шим отбора СР (в полупериодах сетевого напряжения в данном случае это около 10 секунд)
    //unsigned char tDeltaRect=10;  // Дельта ректификации (в десятых градуса Цельсия) в данном случае - это 10 десятых, то есть 1 градус Цельсия
    //unsigned int tEndRectOtbSR=965;  // Температура окончания отбора спирта-ректификата и начала отбора хвостов (в данном случе 96.5 С)
    // Устанавливаем ШИМ отбора СР
    UstPower=PowerRect;
  if (ProcChimOtbCP>=0)
    {
          if (ProcChimOtbGlv>0)
              KlOpen[KLP_GLV_HVS]=(timeChimRectOtbGlv/100)*ProcChimOtbGlv;
          else
              KlOpen[KLP_GLV_HVS]=-ProcChimOtbGlv;
              
          KlOpen[KLP_GLV_HVS]=((long) KlOpen[KLP_GLV_HVS]*(long)ProcChimOtbCP)/100;
          KlClose[KLP_GLV_HVS]=timeChimRectOtbGlv-KlOpen[KLP_GLV_HVS];
      
    }
    else
    {
      KlOpen[KLP_GLV_HVS]=-ProcChimOtbCP;
      KlClose[KLP_GLV_HVS]=timeChimRectOtbSR-KlOpen[KLP_GLV_HVS];
    }
    // Польский буфер закроем.
    KlOpen[KLP_PB]=0;
    KlClose[KLP_PB]=10;


    if (ProcChimSR>0) KlOpen[KLP_SR]=((timeChimRectOtbSR/10)*ProcChimSR)/10;
                 else KlOpen[KLP_SR]=0;
    KlClose[KLP_SR]=timeChimRectOtbSR-KlOpen[KLP_SR];
    
    if (temps[TEMP_RK20]>=tStabSR+tDeltaRect) // Если текущая температура превысила базовую, тогда останавливаем отбор
    {
      StateMachine=5;        
      if (BeepStateProcess) my_beep(BEEP_LONG);
    }

    // Если температура в кубе превысила температуру при которой надо отбирать СР
    if (temps[TEMP_KUB]>=tEndRectOtbSR)
    {  
      StateMachine=7;        
      KlOpen[KLP_SR]=0;// Отключаем клапана отбора СР
      KlClose[KLP_SR]=10;
      if (BeepStateProcess) my_beep(BEEP_LONG);
    }
    else    
      break;    
  case 7: // Отбор Хвостов
    UstPower=PowerRect;
    KlOpen[KLP_SR]=0;
    KlClose[KLP_SR]=10;
    KlOpen[KLP_GLV_HVS]=(timeChimRectOtbGlv/100)*90;
    KlClose[KLP_GLV_HVS]=timeChimRectOtbGlv-KlOpen[KLP_GLV_HVS];
    if (temps[TEMP_KUB]>=tEndRect)
    {  
      StateMachine=8;        
      SecTempPrev=Seconds;// Запомним время, когда закончилась ректификация
      if (BeepStateProcess) my_beep(BEEP_LONG);
    }
    else    
      break;
  case 8:// Ждем три минуты для окончания подачи воды
    UstPower=0;
    digitalWrite(PIN_START_1,!RELAY_HIGH);
    digitalWrite(PIN_START_2,!RELAY_HIGH);
    KlOpen[KLP_GLV_HVS]=0;  // Отключаем клапана отбора хвостов
    KlClose[KLP_GLV_HVS]=10;

    if  (Seconds-SecTempPrev>180+((int)(FlAvtonom>>1))*60)
    {
      // Переводим автомат в конечное состояние
      StateMachine=100;        
      SecondsEnd=Seconds;
      if (BeepStateProcess) my_beep(BEEP_LONG);
    }
    break;
      V3=U_UROVEN; 
      if (V3<UROVEN_ALARM )
      {
        Count_Provodimost++;
        #ifdef TEST
                sprintf(my_tx_buffer,"ALARM VOZVRAT U_UROVEN=%i cnt=%i",U_UROVEN,Count_Provodimost);
                Serial.println(my_tx_buffer);
        #endif      
        // По прошествии минуты устанавливаем флаг сработки.
        if (Count_Provodimost>2) 
        {
          flAlarmUroven=0;
          StateMachine=OldStateMachine;
          Count_Provodimost=0;
        }
      }
      else 
      {
        Count_Provodimost=0;
      }
      break;
  case 101: // Превышение температуры в ТСА!!!
    my_beep(2*BEEP_LONG);
  case 100:// Конечное состояние автомата

    // Отключаем на всякий случай все!
    if (FlToGSM && lastSMSState!=StateMachine) StateToSMS();

    if (StateMachine==100 && BeepEndProcess) my_beep(BEEP_LONG);

    UstPower=0;
    CloseAllKLP();
//    digitalWrite(PIN_REG_ON,LOW);
    digitalWrite(PIN_RZG_ON,!RELAY_HIGH);
    digitalWrite(PIN_ALL_OFF,ALL_OFF_HIGH);
    digitalWrite(PIN_START_1,!RELAY_HIGH);
    digitalWrite(PIN_START_2,!RELAY_HIGH);
    flAllOff=1;

    break;
  }

}
